#! /usr/bin/env node;

const yargs = require("yargs");

const argv = yargs
    .option("apiKey", {
        demandOption: true
    })
    .option("baseUrl", { demandOption: true })
    .option("variable", { demandOption: true })
    .option("value", { demandOption: true })
    .option("projectName", { demandOption: true }).argv;

const url = `${argv.baseUrl}/octopus/api/projects/${argv.projectName}`;
const headers = {
    "X-Octopus-ApiKey": argv.apiKey,
    "Content-Type": "application/json"
};

fetch(url, { headers })
    .then(res => res.json())
    .then(res => {
        if (!res.Links.Variables) {
            console.log("Something went wrong", res);
        }
        const variablesUrl = `${argv.baseUrl}${res.Links.Variables}`;
        fetch(variablesUrl, { headers })
            .then(res => res.json())
            .then(res => {
                const body = {
                    ...res,
                    Variables: res.Variables.map(variable => {
                        if (variable.Name === argv.variable) {
                            return { ...variable, Value: argv.value };
                        }
                        return variable;
                    })
                };

                fetch(variablesUrl, {
                    method: "PUT",
                    body: JSON.stringify(body),
                    headers
                })
                    .then(res => res.json())
                    .then(res => {
                        console.log(
                            "Variable updated to a new value:",
                            res.Variables.find(
                                variable => variable.Name === argv.variable
                            )
                        );
                    });
            });
    });
